﻿using Syncfusion.Grouping;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Chart;
using System.Collections.ObjectModel;

using System.Drawing;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms;

namespace CellGrid
{
    public partial class Form1 : Form
    {     
        private DataTable dt;
        private bool[] str = { true, false };
       
        Viewmodel myViewmodel = new Viewmodel();
        ChartControl chart = new ChartControl();

        ChartSeries series2 = new ChartSeries();

        public Form1()
        {
            InitializeComponent();

            #region DATASOURCE
            dt = new DataTable();
            dt.Columns.Add("Column1",typeof(string));            
            dt.Columns.Add("Column2", typeof(string));
            dt.Columns.Add("Column3", typeof(string));
            dt.Columns.Add("Column4", typeof(string));
            dt.Columns.Add("Column5", typeof(bool));

            Random r = new Random(123421);
            for (int row = 0; row < 300; row++)
            {
                DataRow dr = dt.NewRow();
                dr[0] = "row" + (row + 1) + "col1";                
                dr[1] = "row" + (row + 1) + "col2";
                dr[2] = "row" + (row + 1) + "col3";
                dr[3] = "row" + (row + 1) + "col4";
                dr[4] = str[1];
                dt.Rows.Add(dr);
            }
            #endregion

            this.gridGroupingControl1.DataSource = dt;

            this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;

            this.gridGroupingControl1.TableControlCheckBoxClick += new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCheckBoxClick);
            Timer timer = new Timer();
            timer.Interval = (5 * 1000); // 10 secs            
            timer.Tick += new EventHandler(timer_Tick);
            timer.Start();
            chart.ImprovePerformance = true;
            chart.CalcRegions = false;
            chart.Series[0].EnableStyles = false;
            chart.Series[0].Style.DisplayShadow = false;

            chart.Height = 200;
            chart.Width = 1000;
            chart.Location = new Point(0, 150);
            


            ChartDataBindModel series1BindModel = new ChartDataBindModel();
            series1BindModel.DataSource = myViewmodel.YourCollection;
            series1BindModel.XName = "Y1";
            series1BindModel.YNames = new string[] { "Y2" };
            series2.SeriesModel = series1BindModel;
            series2.Type = ChartSeriesType.Line;
            chart.Series.Add(series2);
            this.Controls.Add(chart);

            Timer timer1 = new Timer();
            timer1.Interval = (5 * 1000); // 10 secs            
            timer1.Tick += new EventHandler(timer_Tick1);
            timer1.Start();
        }
        private void timer_Tick1(object sender, EventArgs e)
        {

            Viewmodel myViewmodel = new Viewmodel();
            ChartDataBindModel sereisbind = new ChartDataBindModel();
            chart.Series[0].SeriesModel = sereisbind;
            sereisbind.DataSource = myViewmodel.YourCollection;
            sereisbind.XName = "Y1";
            sereisbind.YNames = new string[] { "Y2" };

        }
        public class Model
        {
            public double Y1 { get; set; }

            public double Y2 { get; set; }



        }
        public class Viewmodel
        {
            public Viewmodel()
            {
                this.YourCollection = new ObservableCollection<Model>();
                Random random = new Random();
                double num = 0;
                for (int i = 0; i < 4096; i++)
                {
                    num += (random.Next(0, 2) * 10 - 5);
                    YourCollection.Add(new Model() { Y1 = i, Y2 = num });
                }

            }

            public ObservableCollection<Model> YourCollection { get; set; }
        }
    
        #region Event Handlers
        void gridGroupingControl1_TableControlCheckBoxClick(object sender, GridTableControlCellClickEventArgs e)
        {
            GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.TableControl.GetTableViewStyleInfo(e.Inner.RowIndex, e.Inner.ColIndex);
            Record currentRecord = style.TableCellIdentity.DisplayElement.GetRecord();
            //Add or remove the selection for the record based on the CheckBox option.
            if (this.gridGroupingControl1.TableModel[e.Inner.RowIndex, e.Inner.ColIndex].Text == "False")
                currentRecord.SetSelected(true);
            else
                currentRecord.SetSelected(false);
        }

        private void timer_Tick(object sender, EventArgs e)
        {
            
            for (int row = 0; row < 4096; row++)
            {
                Random random = new Random();
                int j = random.Next(1, 3);
                DataRow dr = dt.NewRow();
                dr[0] = "row" + (row + random.Next(1,2)).ToString() + "col1";
                dr[1] = "row" + (row + random.Next(1,3)).ToString() + "col2";
                dr[2] = "row" + (row + random.Next(1,4)).ToString() + "col3";
                dr[3] = "row" + (row + random.Next(1,2)).ToString() + "col4";
                dr[4] = str[1];
                dt.Rows.Add(dr);
            }
            this.gridGroupingControl1.DataSource = dt;

        }
        #endregion

    }
}